/*
* ##################################################### Start StatusPage Addon #####################################################
*/
StatusPage.prototype.appendHeatGenerator = function(parentElement, kimCoID) {

  var thisClass = this;
  for(i=0;i<8;++i)
  {
    parentElement.appendChild(document.createTextNode(""));
    var textNode = document.createTextNode('');

    var span = document.createElement('span');
    span.setAttribute('class', 'text--muted heatgeneratorState');
  
    span.appendChild(textNode);
    parentElement.setAttribute('class','parentHeat')
    parentElement.appendChild(span);
  }

  this.dataBindings.push(function() {
    if (mainSite.currentCOValues && mainSite.currentCOValues.COs) {
      for (var i in mainSite.currentCOValues.COs) {
        var currentCO = mainSite.currentCOValues.COs[i];
        if (kimCoID == currentCO.id) {
          thisClass.updateCO(span, textNode, currentCO)
        }
      }
    }
  });
};

StatusPage.prototype.appendDOMFragmentCOInfosTo = function(parentElement) {
  var span = document.createElement('span');
  span.setAttribute('hidden', '');
  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        span.removeAttribute('hidden');
      } else {
        span.setAttribute('hidden', '');
      }
    });
  parentElement.appendChild(span);
  parentElement = span;

  var knxGatewayErrorCO = 11;
  var kimCoText = i18n.translate("knx_gateway_error") + ": ";
  this.appendDOMFragmentKimCoInfoTo(parentElement, knxGatewayErrorCO, kimCoText);

  parentElement.appendChild(document.createElement("br"));

  var knxGatewayLastErrorCO = 12;
  kimCoText = i18n.translate("knx_gateway_last_error") + ": ";
  this.appendDOMFragmentKimCoInfoTo(parentElement, knxGatewayLastErrorCO, kimCoText);

  parentElement.appendChild(document.createElement("br"));

  
  //Create Field for HeatGen 1-8
  //####################### Heatgenerator States #############################

  var HeatGenStates = 238;
  var kimCoText = i18n.translate("HeatGenError") + ": ";
  this.appendHeatGenerator(parentElement, HeatGenStates, kimCoText);

  parentElement.appendChild(document.createElement("br"));
  //##########################################################################
}


StatusPage.prototype.prepareAppInfo = function(divAppInfomation) {
  headerAppInformation = document.createElement('h3');
  headerAppInformation.setAttribute('class', 'h3');
  headerAppInformation.appendChild(document.createTextNode(i18n.translate('application_information')));
  divAppInfomation.appendChild(headerAppInformation);

  var fragmentAppState = document.createElement('span');
  fragmentAppState.setAttribute('hidden', '');
  divAppInfomation.appendChild(fragmentAppState);
  this.appendDOMFragmentAppStateTo(fragmentAppState);

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        fragmentAppState.removeAttribute('hidden');
      } else {
        fragmentAppState.setAttribute('hidden', '');
      }
    }
  );

  this.appendDOMFragmentCOInfosTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));
}

//Example for default handling of Boolean COs and specific String COs handling
StatusPage.prototype.updateCO = function(span, textNode, currentCO) {
  switch (currentCO.id) {
    case 2:
      break;
    case 12:
      switch (currentCO.value) {
        case "1":
          textNode.nodeValue = i18n.translate("ebus_last_error_" + currentCO.value);
          break;
        case "2":
          textNode.nodeValue = i18n.translate("ebus_last_error_" + currentCO.value);
          break;
        case "3":
          textNode.nodeValue = i18n.translate("ebus_last_error_" + currentCO.value);
          break;
        case "4":
          textNode.nodeValue = i18n.translate("ebus_last_error_" + currentCO.value);
          break;
        case "5":
          textNode.nodeValue = i18n.translate("ebus_last_error_" + currentCO.value);
          break;
        case "6":
          textNode.nodeValue = i18n.translate("ebus_last_error_" + currentCO.value);
          break;
        case "7":
          textNode.nodeValue = i18n.translate("ebus_last_error_" + currentCO.value);
          break;
        default:
          textNode.nodeValue = i18n.translate("ebus_last_error_0");
          break;
      }
      break;
    case 11:
      if (currentCO.value == "1") {
        span.setAttribute('class', 'text--error bold');
        textNode.nodeValue = i18n.translate("error_state_1");
      } else if (currentCO.value == "0") {
        span.setAttribute('class', 'text--muted');
        textNode.nodeValue = i18n.translate("error_state_0");
      }
      break;
    case 238:
      for(i=0;i<8;++i) {
        child =  document.getElementsByClassName("parentHeat")[0].childNodes[5];
        childBreak = document.getElementsByClassName("parentHeat")[0].childNodes[6];
        if(child) {
          document.getElementsByClassName("parentHeat")[0].removeChild(child);
          if(childBreak) {
            document.getElementsByClassName("parentHeat")[0].removeChild(childBreak);
          }
        }
      }
      //leave if json input is invalid
      if(currentCO.value == "") {
        break;
      }

      var jsonData = JSON.parse(currentCO.value);
      var jsonLength = Object.keys(jsonData["Heatgenerators"]).length;
      var heatGeneratorAlreadyset = [];
      var heatGeneratorActive = [];
      var newText = undefined;
      if(document.getElementsByClassName("text--muted heatgeneratorState")!= null) {
        if(span.parentElement !== null) {
         newText = span.parentElement.innerHTML;
        }
      }

      for(i = 0; i < 8;++i) {
        if(jsonData["Heatgenerators"][i] != null) {
          var heatGeneratorNumber = jsonData["Heatgenerators"][i]["Heatgenerator"];
          //if heatgenerator isnt added to active List - add it
          if(!heatGeneratorActive.includes(heatGeneratorNumber)) {
            heatGeneratorActive.push(heatGeneratorNumber);
          }
        }
        heatGeneratorAlreadyset.push(heatGeneratorNumber);
      }

      for(i=0;i<8;++i) {
        child =  document.getElementsByClassName("parentHeat")[0].childNodes[5];
        childBreak = document.getElementsByClassName("parentHeat")[0].childNodes[6];
        if(child) {
          document.getElementsByClassName("parentHeat")[0].removeChild(child);
          if(childBreak) {
            document.getElementsByClassName("parentHeat")[0].removeChild(childBreak);
          }
        }
      }
    //set correct states by active Heatgenerators
    var count = 0;
    document.getElementsByClassName("parentHeat")[0].appendChild(document.createElement("br"));
    document.getElementsByClassName("parentHeat")[0].appendChild(document.createElement("br"));
     for(i = 0; i< 8; ++i) {
       if(heatGeneratorActive.includes(i+1))
       {        
        var errorActive = jsonData["Heatgenerators"][count]["ErrorActive"] ? 1: 0;
        var b = document.createElement('span');
        var stateTxt = document.createTextNode(i18n.translate("error_state_" + errorActive));
        b.appendChild(stateTxt);
        (errorActive) ?  b.setAttribute('class', 'text--error bold') : b.setAttribute('class', 'text--muted');  
        document.getElementsByClassName("parentHeat")[0].appendChild(document.createTextNode(i18n.translate("co_state_238_" + (i))+ ': ',''));
        document.getElementsByClassName("parentHeat")[0].appendChild(b);
        document.getElementsByClassName("parentHeat")[0].appendChild(document.createElement("br"));
        count++;
       }
     }
      break;
    default:
      break;
  }
}
/*
 * ##################################################### End StatusPage Addon #####################################################
 */